#include <stdlib.h>
#include <stdio.h>
#include "list.h"

void print_int(void *i)
{
  printf("%d", *((int *)i));
}  

/* Add two, create new int "object" */
void *add_two(void *i) 
{
  int *j;
  if ((j= (int *)malloc(sizeof(int)))== NULL) { exit(-1); }
  *j= *(int *)i+2;
  return j;
}

/* Same as before, but in-place */
void *inc_two(void *i)
{
  *(int *)i= *(int *)i+2;
  return i;
}

int even(void *i) { return (*( int*)i) % 2 == 0; }

void test()
{
  list_t *l, *l2, *l3, *l4;
  int i, *ip;

  l= NULL;
  for (i= 0; i< 10; i++) {
    if ((ip= (int *)malloc(sizeof(int)))== NULL) { exit(-1); }
    *ip= rand() % 32;
    l= list(ip, l);
  }
  
  print_list(l, print_int);
  printf("Length: %d\n", length(l));

  l2= map(add_two, l);
  printf("After map:\nl2= ");
  print_list(l2, print_int);

  l3= map1(inc_two, l2);
  printf("After map1:\nl2= ");
  print_list(l2, print_int);
  printf("l3= ");
  print_list(l3, print_int);

  l4= filter(even, l2);
  printf("After filter:\nl4= ");
  print_list(l4, print_int);
}

int main(int argc, char *argv[])
{
  test();
  return 0;
}
