/* Listen in C */

typedef struct list_t {
     void          *elem;
     struct list_t *next;
     } list_t;

extern list_t *list(void* hd, list_t *tl);
extern int length(list_t *l);
extern list_t *filter(int f(void *x), list_t *l);
extern list_t *map(void *f(void *x), list_t *l);
extern list_t *map1(void *f(void *x), list_t *l);
extern list_t *map2(void *f(void *x), list_t *l);
extern void mapM_(void f(void *x), list_t *l);
extern void print_list(list_t *l, void print_elem(void *));
